import net.designnation.behaviours.*

class net.designnation.behaviours.BaseWorld
{
	private var parentMCVal			: MovieClip;
	private var baseMCVal			: MovieClip;
	private var mySMachineVal		: SMachine;
	private var BEngineVal			: BEngine;
	
	private static var ES_STOPPED		: Number= 0;
	private static var ES_RUNNING		: Number= 1;
	private static var ES_LOAD_COMPLETED: Number= 2;
	private static var ES_INIT			: Number= 4;
		
	private var entStateVal: Number= ES_STOPPED;
	
	private var id	: Object;


	public function BaseWorld( entId: Object )
	{
		this.mySMachine		= new SMachine(  );
		this.id				= entId;
	}	
	
	public function set parentMC( movieClip_mc: MovieClip )
	{	
		var myClass	= this;
		this.baseMCVal.onEnterFrame	= function( )
		{
			myClass.onEnterFrame;
		};
		
	}
	
	public function get parentMC( ): MovieClip
	{
		return super.parentMC;
	}
		
	public function onEnterFrame(  )
	{	
		this.BEngineVal.doProcess(  );		
	}		
	
	
	public function get entState(  ): Number
	{
		return entStateVal;
	}
	
	public function runEnt( arg: Object )
	{
		this.entStateVal|= ES_RUNNING;
				
				
		trace( "the sMachine " + this.mySMachine );		
		this.mySMachine.startMachine(  );
	}
	
	public function stopEnt(  )
	{
		entStateVal= ES_STOPPED;
		
		mySMachine.stopMachine(  );
	}
	
	public function initEnt( arg: Object )
	{
		entStateVal= ES_INIT;		
	}
	
	public function destroyEnt(  )
	{
		entStateVal= ES_STOPPED;
	}	
	
	public function set mySMachine( SMachine: SMachine )
	{
		mySMachineVal= SMachine;
	}
	
	public function get mySMachine(  ): SMachine
	{
		return mySMachineVal;
	}
	
	public function dispose(  )
	{
		this.baseMCVal.removeMovieClip(  );
	}
	
	public function get BEngine(  ): BEngine
	{
		return this.BEngineVal;
	}
	
	public function set BEngine( BEngineParam: BEngine )
	{
		this.BEngineVal= BEngineParam;
	}
	
}