class net.designnation.behaviours.CallbackDecl
{
	private static var CALLBACKOBJECT_LITERAL: String 	= "CallbackObject";
	private static var CALLBACKMETHOD_LITERAL: String 	= "CallbackMethod";
	private static var CALLBACKSOURCE_LITERAL: String 	= "CallbackSource";
	

	private var callbackObjVal: Object;
	private var callbackMethodVal: String;
	
	public function CallbackDecl( objParam: Object, methodParam: String )
	{		
		this.callbackObj		= objParam;
		this.callbackMethod		= methodParam;		
	}
		
	public function set callbackObj( objParam: Object )
	{
		this.callbackObjVal= objParam;
	}
	
	public function get callbackObj(  ): Object
	{
		return this.callbackObjVal;
	}
	
	public function set callbackMethod( methodParam: String )
	{
		this.callbackMethodVal= methodParam;
	}
	
	public function get callbackMethod(  ): String
	{
		return this.callbackMethodVal;
	}
	
	public function fire( parameter: Object ): Object
	{		
		return this.callbackObjVal[ this.callbackMethodVal ]( parameter );
	}
}
